"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("./utils");
exports.parseCommit = function (version) {
    var diff = version.diff;
    var diffHash = utils_1.getExecResult("git log --pretty=\"%H\" " + diff);
    var hashList = diffHash.split('\n');
    return hashList.map(function (hash) {
        var _a;
        var shortHash = hash.slice(0, 7);
        var subject = utils_1.getExecResult("git show --pretty=\"%s\" -s " + hash);
        var body = utils_1.getExecResult("git show --pretty=\"%b\" -s " + hash);
        var regRet = /^([a-zA-Z][^\(]+)\(?(.*?)\)?\:/.exec(subject);
        var type = '';
        var scope = '';
        var matched = '';
        var pureSubject = subject;
        if (regRet !== null) {
            ;
            _a = __read(regRet, 3), matched = _a[0], type = _a[1], scope = _a[2];
            if (matched) {
                pureSubject = subject.split(matched)[1].trim();
            }
        }
        return {
            hash: hash,
            shortHash: shortHash,
            subject: subject,
            pureSubject: pureSubject,
            type: type,
            scope: scope,
            body: body,
            breakingChange: getBreakingChangeFrom(body)
        };
    });
};
var getBreakingChangeFrom = function (str) {
    var KEY_WORD = 'BREAKING CHANGE: ';
    if (!str) {
        return '';
    }
    return str.split(KEY_WORD)[1] || '';
};
