"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var configParser = __importStar(require("parse-git-config"));
var constant_1 = require("./constant");
var gitConfig = configParser.sync();
if (!gitConfig['remote "origin"']) {
    throw constant_1.ERR_MSG.NO_GIT;
}
var url = gitConfig['remote "origin"'].url;
var remoteUrl = '';
if (url.startsWith('git')) {
    var regRet = /^git@(\S[^\:]+)\:(\w+)\/(\S[^\.]+)/.exec(url);
    if (regRet !== null) {
        var _a = __read(regRet, 4), host = _a[1], user = _a[2], project = _a[3];
        remoteUrl = "https://" + host + "/" + user + "/" + project;
    }
}
else if (url.startsWith('http')) {
    remoteUrl = url.split('.git')[0];
}
var isGithub = /github/.test(remoteUrl);
var isGitlab = /gitlab/.test(remoteUrl);
var isBitbucket = /bitbucket/.test(remoteUrl);
var getRemotePath = function (typeIndex) {
    if (isGithub) {
        return constant_1.REMOTE_PATH_DEF.GITHUB[typeIndex];
    }
    if (isGitlab) {
        return constant_1.REMOTE_PATH_DEF.GITLAB[typeIndex];
    }
    if (isBitbucket) {
        return constant_1.REMOTE_PATH_DEF.BITBUCKET[typeIndex];
    }
};
exports.getRemoteLink = function () {
    return {
        commitLink: remoteUrl + "/" + getRemotePath(0),
        issueLink: remoteUrl + "/" + getRemotePath(1),
        mergeLink: remoteUrl + "/" + getRemotePath(2),
        compareLink: remoteUrl + "/" + getRemotePath(3)
    };
};
exports.getRemoteUrl = function () { return remoteUrl; };
